﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer {
  using Common;
  using Data;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class IntegerConstantErcValue : ConstantsWeightedErcValue<int, IntArray> {

    public IntegerConstantErcValue() : this(false, 1d) { }

    public IntegerConstantErcValue(params int[] constants) : this(true, 1d, constants) { }

    public IntegerConstantErcValue(bool isEnabled, double weight = 1d, params int[] constants)
      : base(isEnabled, new IntArray(constants), weight) {
      Name = "Integer constants";
    }

    [StorableConstructor]
    public IntegerConstantErcValue(bool deserializing) : base(deserializing) { }

    public IntegerConstantErcValue(IntegerConstantErcValue origin, Cloner cloner) : base(origin, cloner) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntegerConstantErcValue(this, cloner);
    }
  }
}
