﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
  public abstract class StatelessExpression : Expression {
    private int hashCode;

    protected StatelessExpression() {
      hashCode = GetType().GetHashCode();
    }

    public override int GetHashCode() {
      return hashCode;
    }

    public override bool Equals(object obj) {
      return ReferenceEquals(this, obj) ||
             hashCode == obj.GetHashCode();
    }
  }
}